=== modified file 'drizzled/schema_identifier.cc'
--- drizzled/schema_identifier.cc	2010-05-21 20:29:22 +0000
+++ drizzled/schema_identifier.cc	2010-06-11 21:47:01 +0000
@@ -133,19 +133,27 @@
   return false;
 }
 
+SchemaIdentifier::SchemaIdentifier(const std::string &db_arg) :
+  db(db_arg),
+  lower_db(db_arg)
+{ 
+  std::transform(lower_db.begin(), lower_db.end(),
+                 lower_db.begin(), ::tolower);
+
+  if (not lower_db.empty())
+  {
+    drizzled::build_schema_filename(db_path, lower_db.c_str());
+    assert(db_path.length()); // TODO throw exception, this is a possibility
+  }
+}
+
 const std::string &SchemaIdentifier::getSQLPath()
 {
   return getSchemaName();
 }
 
-const std::string &SchemaIdentifier::getPath()
+const std::string &SchemaIdentifier::getPath() const
 {
-  if (db_path.empty() && not lower_db.empty())
-  {
-    drizzled::build_schema_filename(db_path, lower_db.c_str());
-    assert(db_path.length()); // TODO throw exception, this is a possibility
-  }
-
   return db_path;
 }
 
@@ -157,7 +165,7 @@
   return arg == lower_db;
 }
 
-bool SchemaIdentifier::isValid()
+bool SchemaIdentifier::isValid() const
 {
   if (lower_db.empty())
     return false;

=== modified file 'drizzled/schema_identifier.h'
--- drizzled/schema_identifier.h	2010-06-06 18:22:48 +0000
+++ drizzled/schema_identifier.h	2010-06-11 21:47:01 +0000
@@ -63,26 +63,20 @@
   }
 
 public:
-  SchemaIdentifier(const std::string &db_arg) :
-    db(db_arg),
-    lower_db(db_arg)
-  { 
-    std::transform(lower_db.begin(), lower_db.end(),
-                   lower_db.begin(), ::tolower);
-  }
+  SchemaIdentifier(const std::string &db_arg);
 
   virtual ~SchemaIdentifier()
   { }
 
   virtual const std::string &getSQLPath();
-  const std::string &getPath();
+  const std::string &getPath() const;
 
   const std::string &getSchemaName() const
   {
     return db;
   }
 
-  bool isValid();
+  bool isValid() const;
   bool compare(std::string arg) const;
 
   friend bool operator<(const SchemaIdentifier &left, const SchemaIdentifier &right)

